#pragma once

#include "stdafx.h"
#include "MDraw.h"

static ULONG_PTR gdiplusToken = NULL;

void MGdiplusStartup()
{
	GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
}

void MGdiplusShutdown()
{
	//Ӵ˴IMAGEһֱΪNULL
	Gdiplus::GdiplusShutdown(gdiplusToken);
}

void GetBkImg(CDC *pDC,Image* &img,int width,int height)
{
	CDC MemDC;
	CBitmap memBmp;
	MemDC.CreateCompatibleDC(pDC);
	memBmp.CreateCompatibleBitmap(pDC, width, height);
	CBitmap *pOldmap =  MemDC.SelectObject(&memBmp);
	//һԭȵı
	MemDC.BitBlt(0, 0, width, height, pDC, 0, 0, SRCCOPY);

	//
	if(img == NULL)
		BitmapToImage(&memBmp,img);
	//ͼӦǺڵãֱɾ
	pOldmap->DeleteObject();
	MemDC.DeleteDC();
	memBmp.DeleteObject();
	ReleaseDC(NULL,MemDC.m_hDC);
}

void BitmapToImage(CBitmap *pBitmap,Image* &img)
{
	//õλͼľ BitmapImage
	HBITMAP  hBmp = (HBITMAP)pBitmap->GetSafeHandle();
	//һλͼBitmapλͼ
	img = new Bitmap(hBmp,NULL);
}

void ImageFromID(int IDB_ID,Image* &_outImg)
{
	LPCTSTR lpType = T("PNG");
	if(lpType == RT_BITMAP)
	{
		//GDI+ can not load RT_BITMAP resouce, 
		//because they are predefined resource, 
		//they don't contains the image file header.
		return;
	}
	HINSTANCE hInst = AfxGetResourceHandle();
	HRSRC hRsrc = ::FindResource(hInst,MAKEINTRESOURCE(IDB_ID),lpType);
	if (!hRsrc)
		return;
	DWORD len = SizeofResource(hInst, hRsrc);  
	BYTE* lpRsrc = (BYTE*)LoadResource(hInst, hRsrc);  
	if (!lpRsrc)
		return;
	HGLOBAL m_hMem = GlobalAlloc(GMEM_FIXED, len);
	BYTE* pmem = (BYTE*)GlobalLock(m_hMem); 
	//memcpy(pmem,lpRsrc,len);
	memcpy_s(pmem,len,lpRsrc,len);
	IStream* pstm;
	if (CreateStreamOnHGlobal(m_hMem,FALSE,&pstm) == S_OK)
	{
		_outImg = new Image(pstm);
		GlobalUnlock(m_hMem);
		pstm->Release();
	}
	FreeResource(lpRsrc);
}

// ͼƬ߿
void DrawImage(Graphics &graphics,Image* image,REAL x, REAL y,
	REAL srcx, REAL srcy,REAL srcwidth,REAL srcheight,Unit srcUnit)
{
	graphics.DrawImage(image,x,y,srcx,srcy,srcwidth,srcheight,UnitPixel);
}